Imports iNTERFACEWARE.Chameleon

Public Class ServerForm
    Inherits System.Windows.Forms.Form
    Implements Log
    Dim Engine As New ServerEngine()
    Dim AckEngine As New DynamicEngine()
    Dim NackEngine As New DynamicEngine()
    Dim CR, LF, CRLF As String
    Const MAX_MESSAGE_SIZE As Long = 200
    ' According to MSDN, the limit for the text box size is 32K
    Const MAX_TEXT_SIZE As Long = 30000
    Const MESSAGE_DEFINITION_FILE As String = "..\test.vmd"

    ' This application is a simple example of using the Chameleon generated objects in a 'Client'
    ' configuration.  It is intended to be a helpful starting point in understanding how to use these objects
    ' but must be fleshed out in the following areas to provide a full solution for an
    ' application HL7 interface:
    ' 1) You will need to work out how your application will handle logging of messages
    '    and data, in particular how bad transactions should be logged.
    ' 2) The code will need to be modified to insert the parsed data into a database whether
    '    by using explicit database calls or by going through some type of middle tier layer that
    '    your application may support.
    ' 3) Some customers choose to deploy HL7 interfaces as Windows Services.  This can be done
    '    easily with Chameleon.  One thing to keep in mind though is that the networking components
    '    supplied with Chameleon require a Windows 'message loop'.  Often times Windows Services do
    '    not have a message loop - but one can be easily set up by invoking RunMessageLoop on
    '    the networking component supplied with Chameleon.  See the manual for running Chameleon
    '    within services.
    ' 4) Definitely take the time to read the manual and go through the tutorials after looking
    '    at this example before attempting to deploy a production solution.  We do provide custom
    '    onsite training and technical implementation services if you require them.
    '
    ' If you are looking for a much more complete 'out of the box' solution for your HL7 needs it would be
    ' a good idea to evaluate Iguana - Iguana is powered by Chameleon but
    ' provides a complete runtime web based infrastructure for your HL7 interfaces.
    ' So it provides advanced logging and monitoring capability for you
    ' which makes it a very attractive option for many customers.


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblConfiguration As System.Windows.Forms.Label
    Friend WithEvents cbConfiguration As System.Windows.Forms.ComboBox
    Friend WithEvents btnStartStopListen As System.Windows.Forms.Button
    Friend WithEvents txtMain As System.Windows.Forms.TextBox
    Friend WithEvents txtPort As System.Windows.Forms.TextBox
    Friend WithEvents lblPort As System.Windows.Forms.Label
    Friend WithEvents LlpServer As iNTERFACEWARE.Chameleon.LlpServer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.txtMain = New System.Windows.Forms.TextBox
        Me.txtPort = New System.Windows.Forms.TextBox
        Me.btnStartStopListen = New System.Windows.Forms.Button
        Me.lblConfiguration = New System.Windows.Forms.Label
        Me.cbConfiguration = New System.Windows.Forms.ComboBox
        Me.lblPort = New System.Windows.Forms.Label
        Me.LlpServer = New iNTERFACEWARE.Chameleon.LlpServer
        Me.SuspendLayout()
        '
        'txtMain
        '
        Me.txtMain.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.txtMain.BackColor = System.Drawing.SystemColors.HighlightText
	Me.txtMain.Font = New System.Drawing.Font("Courier New", 9.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtMain.Location = New System.Drawing.Point(0, 45)
        Me.txtMain.Multiline = True
        Me.txtMain.Name = "txtMain"
        Me.txtMain.ReadOnly = True
        Me.txtMain.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me.txtMain.Size = New System.Drawing.Size(540, 266)
        Me.txtMain.TabIndex = 2
	Me.txtMain.TabStop = false
	Me.txtMain.WordWrap = false
        Me.txtMain.Text = ""
        '
        'txtPort
        '
        Me.txtPort.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.txtPort.Location = New System.Drawing.Point(56, 329)
        Me.txtPort.Name = "txtPort"
        Me.txtPort.Size = New System.Drawing.Size(88, 20)
        Me.txtPort.TabIndex = 4
        Me.txtPort.Text = "5123"
        '
        'btnStartStopListen
        '
        Me.btnStartStopListen.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.btnStartStopListen.Location = New System.Drawing.Point(200, 329)
        Me.btnStartStopListen.Name = "btnStartStopListen"
        Me.btnStartStopListen.Size = New System.Drawing.Size(128, 24)
        Me.btnStartStopListen.TabIndex = 5
        Me.btnStartStopListen.Text = "&Start Listening"
        '
        'lblConfiguration
        '
        Me.lblConfiguration.Location = New System.Drawing.Point(35, 12)
	Me.lblConfiguration.Size = New System.Drawing.Size(120, 24)
        Me.lblConfiguration.Name = "lblConfiguration"
        Me.lblConfiguration.TabIndex = 0
        Me.lblConfiguration.Text = "Current Configuration:"
        Me.lblConfiguration.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'cbConfiguration
        '
        Me.cbConfiguration.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cbConfiguration.Location = New System.Drawing.Point(180, 12)
        Me.cbConfiguration.Name = "cbConfiguration"
        Me.cbConfiguration.Size = New System.Drawing.Size(300, 21)
        Me.cbConfiguration.TabIndex = 1
        '
        'lblPort
        '
        Me.lblPort.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left), System.Windows.Forms.AnchorStyles)
        Me.lblPort.Location = New System.Drawing.Point(8, 329)
        Me.lblPort.Name = "lblPort"
        Me.lblPort.Size = New System.Drawing.Size(40, 24)
        Me.lblPort.TabIndex = 3
        Me.lblPort.Text = "Port:"
        Me.lblPort.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'LlpServer
        '
        Me.LlpServer.HeaderBlock = ""
        Me.LlpServer.TrailerBlock = "" & Microsoft.VisualBasic.ChrW(13)
        '
        'PrefixTestServer
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(542, 369)
        Me.Controls.Add(Me.lblPort)
        Me.Controls.Add(Me.cbConfiguration)
        Me.Controls.Add(Me.lblConfiguration)
        Me.Controls.Add(Me.btnStartStopListen)
        Me.Controls.Add(Me.txtPort)
        Me.Controls.Add(Me.txtMain)
        Me.Name = "PrefixTestServer"
        Me.Text = "Server"
        Me.ResumeLayout(False)

    End Sub

#End Region

    <STAThread()> _
    Shared Sub Main()
        Try
            Dim FormMain As New ServerForm()
            Application.Run(FormMain)
        Catch ex As Exception
            MessageBox.Show(ex.ToString(), "Server", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub PrefixTestServer_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Define line feed characters
        CR = Chr(13)
        LF = Chr(10)
        CRLF = CR & LF

        'Load the Definition File
        Try
            ' The first step in making the generated HL7engine component useable is to load
            ' the message definition or 'vmd' file.  This file contains all the definitions
            ' for the messages, how they are identified and how they should be mapped into the
            ' generated data objects based on the tables that you define in the Chameleon GUI.

            ' HL7engine is a generated engine which means that it has an interface based
            ' on the Messages and Tables you define in your vmd file.  The use of stub code is
            ' helpful since it means that the compiler can catch typos or spelling mistakes of fields at compile
            ' rather than run time.  However it is not the only way you can use Chameleon.  It is
            ' possible to use a non-stubcode interface to the Chameleon parsing engine which we call
            ' the 'dynamic interface'.  Please review the manual documentation for more details if you
            ' need this functionality - most customers find that the stub code interface works well for
            ' their applications.
            Engine.Load(MESSAGE_DEFINITION_FILE)
            DisplayOutput("Loaded " + MESSAGE_DEFINITION_FILE)

            ' This example has two other Chameleon HL7 engines to help with the generation of
            ' HL7 ACKnowledgement and Negative ACKnowledgment messages.  In this case each engine
            ' object is not a stubcode generated engine but is a dynamic engine.  For more information
            ' please read the Chameleon manual about auto-acknowledgement.
            AckEngine.Load("..\autoack.vmd")
            DisplayOutput("Loaded autoack.vmd")

            NackEngine.Load("..\autonack.vmd")
            DisplayOutput("Loaded autonack.vmd")
            DisplayOutput("")

            Engine.AddLog(Me)
        Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
            HandleError(ex.ToString())
        End Try

        ' Setting up the combo box is just part of mechanics of this example which
        ' is for teaching purposes only.  A real HL7 client would most likely be part
        ' of a backend service.
        Dim configList As New ArrayList
        Dim configIndex As Long
        For configIndex = 0 To (Engine.CountOfConfig - 1)
            configList.Add(Engine.ConfigName(configIndex))
        Next configIndex
        cbConfiguration.DataSource = configList
        cbConfiguration.SelectedIndex = Engine.CurrentConfigIndex
        DisplayOutput("Current Configuration is: " + Engine.ConfigName(cbConfiguration.SelectedIndex) + CRLF)
    End Sub

    ' This code is just part of the mechanics of this example.
    Private Sub cbConfiguration_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbConfiguration.SelectionChangeCommitted
        DisplayOutput("Set Current Configuration to: " + cbConfiguration.Text + CRLF)
        Engine.CurrentConfigIndex = cbConfiguration.SelectedIndex
    End Sub

    Private Sub btnStartStopListen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStartStopListen.Click
        Dim ErrorEvent As String = ""
        Try

            If LlpServer.IsListening = True Then
                ErrorEvent = "Stopping Listener"
                LlpServer.StopListen()
                LlpServer.DisconnectAllClients()
                DisplayOutput("Stopped Listening on current port " + CRLF)
                btnStartStopListen.Text = "&Start Listening"
            Else
                ErrorEvent = "Starting Listener"
                Dim portNumber As Integer
                Try
                    portNumber = CInt(txtPort.Text)
                Catch
                    HandleError("Invalid port " + txtPort.Text + " using default port 5123 instead" + CRLF)
                    txtPort.Text = "5123"
                End Try
                LlpServer.StartListen(Val(txtPort.Text))
                DisplayOutput("Listening on Port " + txtPort.Text + CRLF)
                btnStartStopListen.Text = "&Stop Listening"
            End If
        Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
            HandleError("Error when " + ErrorEvent + " : " + ex.ToString)
        End Try

    End Sub

    ' For demonstration purposes, all runtime errors will be displayed in the output text box
    Private Sub HandleError(ByVal ErrorText As String)
        DisplayOutput(ErrorText)
    End Sub

    ' This code is only for demonstration purposes.  Memo controls can only take a certain amount
    ' of data - 32k at the time this example was written.  As a result we check the length of
    ' the memo control and truncate it if it reaches this limit.
    '
    ' A real HL7 interface should have some type of system of logging into log files.  Iguana for
    ' instance has a very nice logging system that allows administrators to drill into and browse
    ' processed messages and errors.  How you implement this logging is up to your requirements
    ' for run time management of your HL7 interface.
    Public Sub DisplayOutput(ByVal Output As String)
        If Len(txtMain.Text) > MAX_TEXT_SIZE Then
            txtMain.Text = txtMain.Text.Substring(txtMain.TextLength / 2)
        End If
        txtMain.AppendText(Output + CRLF)
    End Sub

    ' This is the first event we would expect to get from a client connecting to us.  Notice
    ' that all the networking events have a 'Client' object that can be used to interact with
    ' the peer machine that is sending HL7 data.
    Private Sub LlpServer_ClientConnected(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal Client As iNTERFACEWARE.Chameleon.LlpConnection) Handles LlpServer.ClientConnected
        DisplayOutput("Client connected from " + Client.RemoteIpAddressAsString + CRLF)
    End Sub

    ' This is the event we would expect when a client disconnects.  Note that sometimes
    ' if the client is not well behaved we may not receive this event.
    Private Sub svrLlpServer_ClientDisconnected(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal Client As iNTERFACEWARE.Chameleon.LlpConnection) Handles LlpServer.ClientDisconnected
        DisplayOutput("Client disconnected from " + Client.RemoteIpAddressAsString + CRLF)
    End Sub


    ' This event is fired if we have an error on a given TCP/IP connection.  When you
    ' develop a real application you should log this information for troubleshooting purposes.
    Private Sub LlpServer_ClientErrorReceived(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal Client As iNTERFACEWARE.Chameleon.LlpConnection, ByVal ErrorMessage As String, ByVal ErrorCode As Integer) Handles LlpServer.ClientErrorReceived
        HandleError("Client error from " + Client.RemoteIpAddressAsString + ":" + ErrorMessage + CRLF)
    End Sub

    ' This event is fired if we have an error related to the listening socket itself rather
    ' than a specific connection.  In practice this event is rarely invoked.
    Private Sub LlpServer_ErrorReceived(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal ErrorMessage As String, ByVal Code As Integer) Handles LlpServer.ErrorReceived
        HandleError("Server error: " + ErrorMessage)
    End Sub

    ' HL7 data is sent via the Lower Layer Protocol.  Read the manual for more detailed background
    ' on this protocol.  If you have a badly behaved counter party it is possible they may send data
    ' that is outside of the LLP start of block and end of block characters - this event will tell
    ' you when this problem occurs.
    Private Sub LlpServer_DataIgnored(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal Client As iNTERFACEWARE.Chameleon.LlpConnection, ByVal Data As String) Handles LlpServer.DataIgnored
        DisplayOutput("Ignored data outside of LLP connection from client " + Client.RemoteIpAddress + ":")
        DisplayOutput(Engine.MakeMessagePrintable(Data) + CRLF)
    End Sub

    ' This event is the main entry point for where we get an actual HL7 message off
    ' 'the wire' from a connected peer.  Notice that we 'manually' invoke the
    ' ParseMessage method on the HL7Engine object.  This will
    ' fire one of the generated onMessage events which follow
    ' after this method or the ParseError method.
    '
    ' The LLP TCP/IP transport components are not tightly coupled to the
    ' HL7Engine object.  You can use any kind of transport you like with Chameleon, including
    ' your own transports or third party components.
    '
    ' In this application we do not block on events - this is because the
    ' networking components are asynchronous.  You can write synchronous applications using
    ' Chameleon but you would need to use another transport mechanism other than the LLP TCP/IP
    ' components supplied here.
    Private Sub LlpServer_MessageReceived(ByVal sender As System.Object, ByVal e As System.EventArgs, ByVal Client As iNTERFACEWARE.Chameleon.LlpConnection, ByVal Message As String) Handles LlpServer.MessageReceived
        Dim responseMessage As String

        ' All our networking events from llpServer have a Client object which gives us
        ' information about the host we received a message from.
        DisplayOutput("Received message from " + Client.RemoteIpAddressAsString + ":")

        ' We use the MakeMessagePrintable function to 'pretty print'
        ' the HL7 message into a format that can be easily read in
        ' the log files.  This function converts \r characters into the
        ' string given in the second argument of MakeMessagePrintable.
        '    i.e. in this case a \r\n sequence which displays nicely in the memo control.
        ' The third argument is the maximum length of the message before
        ' we truncate it.  This is done because displaying data within a memo
        ' control is actually very slow - so displaying a message of 100k in
        ' the memo control window can give the appearance of hanging the server.
        ' (i.e. a long blocking event)
        DisplayOutput(LlpServer.MakeMessagePrintable(Message, CRLF, MAX_TEXT_SIZE))

        ' We parse the message with Chameleon using the Parse procdure
        Try
            Engine.ParseMessage(Message, Nothing)
        Catch ex As iNTERFACEWARE.Chameleon.ChameleonException
            HandleError("Error while parsing message " + ex.ToString + CRLF)
        End Try

        ' The following code generates an auto-acknowledgement or an negative acknowledgement if
        ' the generation of auto-ack fails
        Try
            responseMessage = AckEngine.GenerateAckFromMessage(Message)
        Catch ex As Exception
            HandleError("Error while generating Ack, sending a Nack instead" + CRLF)
            Try
                responseMessage = NackEngine.GenerateAckFromMessage(Message)
            Catch ex2 As Exception
                HandleError("Error generating Nack, sending a hard-coded Nack instead" + CRLF)
                responseMessage = "MSH|^~\\&|ACME|ACME_APP|XYZ|XYZ_APP|||NACK|XXX|P|2.4|" + CR + "MSA|AA|XXX|" + CR
            End Try

        End Try
        ' Sends the generated ack/nack
        Client.SendMessage(responseMessage)
    End Sub

    Sub Println(ByVal line As String) Implements Log.Println
        DisplayOutput(line)
    End Sub


End Class


